#2003 IBM_PROLOG_BEGIN_TAG 
#2003 This is an automatically generated prolog. 
#2003  
#2003  
#2003  
#2003 Licensed Materials - Property of IBM 
#2003  
#2003 (C) COPYRIGHT International Business Machines Corp. 2003,2006 
#2003 All Rights Reserved 
#2003  
#2003 US Government Users Restricted Rights - Use, duplication or 
#2003 disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#2003  
#2003 IBM_PROLOG_END_TAG 
package CHARM_cli_xtrutils;
#"@(#)62   1.12.1.6   src/sam/CHARM/cli/pm/CHARM_cli_xtrutils.pm.perl, charmcli, sam_rsa12q, rsa12q0517a 4/7/05 14:50:21"
######################################################################
#                                                                    #
# Package: CHARM_cli_xtrutils.pm                                     #
#                                                                    #
# Description:                                                       #
#   This package contains more utility/common subroutines for the    #
#   Cluster High Availability Recovery Manager (CHARM) CLI commands. #
#                                                                    #
# Subroutines Available:                                             #
#                                                                    #
#   process_input_data  - process the attr=value pairs that are used #
#     to define this resource and were input by the user on the      #
#     command line via an input file.                                # 
#                                                                    #
#   get_sd_defs   -   Will get this resource's persistent attribute  #
#     SD definitions and build a hash indexible via the attribute    #
#     program name with the attributes element names and types stored#
#     as data.                                                       #
#                                                                    #
#   build_resource - function to build up the hash of persistent attr#
#     to be used in defining the resource. Merging the {at_name},    #
#     {at_value}, {at_dtype} all into one structure and validating   #
#     the input data as its processed.                               #
#                                                                    #
#   translate_attr_values - function to translate persistent attrib- #
#     ute values to recognizable attribute types and values. Will    #
#     return a bad return code if not translatable or recognized.    #
#                                                                    #
#   VerifyMemberOf -  Will check the validity of the MemberOf attrib-#
#     ute of managed resources.                                      #
#                                                                    #
#   VerifyPolicy   -  Will check the validity of the policy for the  #
#     equivalency.                                                   #
#                                                                    #
#   VerifyManagedResource - Will check the validity of the managed   #
#     resource.                                                      #
#                                                                    #
#   VerifyMembership  - Will check the validity of the Membership    #
#     attribute value for Equivalency.                               #
#                                                                    #
#   VerifySource   -  Will check the validity of the Source resources#
#     in a relationship.                                             #
#                                                                    #
#   VerifyTarget   -  Will check the validity of the Target resources#
#     in a relationship.                                             #
#                                                                    #
#   VerifyMandatory  -  Will check the validity of the Mandatory     #
#     attribute value for managed resources.                         #
#                                                                    #
#   VerifyMinNecessary -   Will check the validity of the Minimum    #
#     Necessary attribute value for equivalency.                     #
#                                                                    #
#   VerifyMemberLocation - Will check the validity of the MemberLoca-#
#     Location value for resource groups.                            #
#                                                                    #
#   VerifyPriority  - Will check the validity of the priority value  #
#     for resource groups.                                           #
#                                                                    #
#   VerifyAllowedNode - Will check the validity of the Allowed Node  #
#     value for resource groups.                                     #
#                                                                    #
#   VerifyNominalState - Will check the validity of the Nominal State#
#     value for resource groups.                                     #
#                                                                    #
#   setup_mkrsrcapi - function to add a parameter specification to be#
#     used later for mkrsrc-api.                                     #
#                                                                    #
#   make_resources      - Uses the mkrsrc-api interface to define    #
#     the resources with the specified attributes for the specified  #
#     class.                                                         #
#                                                                    #
#   get_mgdrscehandles - Function will parse input format for the    #
#     managed resources and then find its corresponding resource     #
#     handles from its class.                                        #
#                                                                    #
#   get_sourcehandles - Function will parse input format for the     #
#     resource and then find its corresponding resource handles from #
#     its class.                                                     #
#                                                                    #
#   get_sd_element_dtypes - for the specified attribute name return  #
#     an array of this SDs element's data types in element index     #
#     order.                                                         #
#                                                                    #
#   VerifyActionRequest - Verifies the validity of the action applied#
#     on the specified resource.                                     #
#                                                                    #
#   VerifyPriorityRequest - Verifies the validity of the action appl-#
#     ied on the specified resource.                                 #
#                                                                    #
#   getNodeIds -   Find the Node ids of the specified nodes in the   #
#     cluster.                                                       #
#                                                                    #
#   hex2chr  -  This will convert a binary data to its ASCII repres- #
#     entation.                                                      #
#                                                                    #
#   translate_PriorityRequest - function to translate priority reque-#
#     sts to recognizable values.                                    #
#                                                                    #
#   translate_ActionRequest - function to translate action requests  #
#    to recognizable values.                                         #
#                                                                    #
#   translate_ActiveReqStatus - function to translate active request #
#     status to recognizable values.                                 #
#                                                                    #
#   translate_DesiredState    - function to translate Desired state  #
#      of AutomationDetails to recognizable values.                  #
#                                                                    #
#   translate_CompoundState    - function to translate Compound state#
#      of AutomationDetails to recognizable values.                  #
#                                                                    #
#   translate_ObservedState    - function to translate Observed state#
#      of AutomationDetails to recognizable values.                  #
#                                                                    #
#   translate_AutomationState - function to translate Automation     #
#      state of AutomationDetails to recognizable values.            #
#                                                                    #
#   translate_BindingState    - function to translate Binding state  #
#      of AutomationDetails to recognizable values.                  #
#                                                                    #
#   translate_StartableState  - function to translate Startable state#
#      of AutomationDetails to recognizable values.                  #
#                                                                    #
#   translate_HealthState    - function to translate Health state    #
#      of AutomationDetails to recognizable values.                  #
#                                                                    #
# Examples:                                                          #
#   printCEMsg("EMsgCUcliBadOperand", $rsrc_class);                  #
#                                                                    #
#--------------------------------------------------------------------#
# Inputs:                                                            #
#   /usr/sbin/rsct/msgmaps/samcli.samcli.map - message mapping       #
#                                                                    #
# Outputs:                                                           #
#   stdout - common informational messages that get displayed.       #
#   stderr - common error messages that get displayed.               #
#                                                                    #
# External References:                                               #
#   Commands: ctdspmsg                                               #
#                                                                    #
# Tab Settings:                                                      #
#   4 and tabs should be expanded to spaces before saving this file. #
#   in vi:  (:set ts=4  and   :%!expand -4)                          #
#                                                                    #
# Change Activity:                                                   #
#   030602 JKA 95169: Initial design & write. Enchanced file options.#
#   031008 JKA 100233:Modified code to accept valid Allowed Node     #
#                     parameters from inputfile. Also made simple fix#
#                     for membership data for equivalency from Input #
#                     file.                                          #
#   031014 JKA 100455:Modified code to accept samreq commands "rgreq"#
#                     , "rgmbrreq", and "lsrgreq".  Added the follo- #
#                     functions in this file:                        #
#                     VerifyActionRequest                            #
#                     VerifyPriorityRequest                          #
#                     getNodeIds                                     #
#                     hex2chr                                        #
#                     translate_PriorityRequest                      #
#                     translate_ActionRequest                        #
#                     translate_ActiveReqStatus                      #
#   031021 JKA 100382:Modified code to translate Automation details  #
#                     for TEC. Added the following functions in this #
#                     file:                                          #
#                       translate_DesiredState                       #
#                       translate_CompoundState                      #
#                       translate_ObservedState                      #
#                       translate_BindingState                       #
#                       translate_AutomationState                    #
#                       translate_StartableState                     #
#                       translate_HealthState                        #
#   031027 JKA 100382:Modified code to translate move status attribu-#
#                     tes to recognizable values.                    #
#   031209 JKA 102293:Modified code to update Automation constants   #
#                     to correct  values.                            #
#   040217 JKA 104079:Modified code to update MoveStatus constants to#
#                     correct values in the charm_ribm.hpp. Previous-#
#                     ly constants were referenced from SAMREQ imple-#
#                     mentation document.                            #
#   040330 JKA 106710:Modified code to change Observed State value of# 
#                     Failed to FailedOffline as defect 103667.      #
#   040418 JKA 105863:Changes to adjust to x5c japanese charaters.   #
#   040426 JKA 108069:Included Excluded List for -f option of "mkrg".#
#   040817 MJH 112355:$A0 - Verify exact keyword matches for Policy, #
#                     Action, Mandatory, Location, Nominal State,    #
#                     priority.                                      #
#   040926 MJH 113711:$A1 -  Add code to support Event Subsrciption  #
#   041007 MJH 113537 $A2 - Remove  {1,1} from 112355 to prevent     #
#                      Perl warning messages.                        #
#   041116 JKA 115207:Event subscription requirements.               #
#                     - Added functions "update_subscriptions_lists" #
#                     - Included ES_FA_ALL as a valid EventFamily.   #
#   050407 AS  119949:DCR036 change StartableState to ControlState   #
#   050610 AS  123450:DCR03GA added missing ControlState             #
######################################################################

use Exporter ();
@ISA = qw(Exporter);
@EXPORT_OK = qw(
    process_input_data
    make_resources
    VerifyPriority
    VerifyNominalState
    VerifyMemberLocation
    VerifyAllowedNode
    VerifyActionRequest
    VerifyPriorityRequest
    getNodeIds
    hex2chr
    $CURRENT_ACTIVE $REMOVE_DONE
    translate_PriorityRequest
    translate_ActionRequest
    translate_ActiveReqStatus
    translate_DesiredState
    translate_CompoundState
    translate_ObservedState
    translate_BindingState
    translate_AutomationState
    translate_StartableState
    translate_HealthState
    translate_movestatus
    translate_EventFilter                    
    translate_EventFamily                    
    update_subscription_lists
);  # $A1

use lib "/usr/sbin/rsct/pm";
use locale;

use autouse CT_cli_input_utils => qw(
    process_input_file
    process_cmdline_input
);
 
 
use CHARM_cli_utils qw(
    error_exit
    printCIMsg
    printCEMsg
    call_lsrsrcinfo_command
    chrsrcapi_resources
    rmrsrcapi_resources
    mkrsrcapi_resources
    charm_cli_timestamp
    runactapi_resources
    checkifvalidrelationship
    checkifvalidcondition
    gen_operands
    parse_sourceresources
    parse_targetresources
    parse_resources
    check_if_handles_exists
    check_if_resources_exists
    get_resourcehandles
    get_resource_names
    get_resource_attributes
    get_allowednode_handle
    gen_new_attrib_list
    allowednodeiswhat
    check_if_members_are_allowed
    escape_chars
    unescape_chars
    replace_chars
    $CTDIR $CTBINDIR
    $RSRCGRP $RSRCMGD $RSRCREL $RSRCNODE $RSRCEQU $RSRCCTRL
    $ES_FA_CONFIG $ES_FA_STATUS $ES_FA_ALL $ES_FI_NONE $ES_FI_INITIAL
    $RMC_CLI_USER_ERROR
    $GARBAGE
);

use MC_cli_utils qw(
    get_p_attr_defs_api
    get_arg_defs_api
    get_sd_defs_api
    convert_input_value_api
    build_cmd_arg_sd_api
    $RMC_RSRC_PATTR_REQD_FOR_DEFINE
    $RMC_RSRC_PATTR_OPTION_FOR_DEFINE
);
use CHARM_cli_rc qw(:return_codes);

#--------------------------------------------------------------------#
# Global Variables                                                   #
#--------------------------------------------------------------------#

$ENV{'CT_CLI_QUOTE_STRING'}  = 1;                 # Enable quotes               
$ENV{'CT_MANAGEMENT_SCOPE'}  = 2;                 # cluster Mode                

# RMC Command Names
$DELIMITER          = "::";                       # a delimiter to use
$CMD_LIMIT          = 20000;                      # mkrsrc-api cmd limit
                                                  # lsrsrc if no condition found
$EQUIV_ALL = "0x0000 0x0000 0x00000000 0x00000000 0x00000000 0x00000000";
                                                  # Equivalency of all Nodes
$NULL               = "ALL";                      # All Equivalency String
$RGrp               = "";
@NodeNameList       = ();
$FALSE              = 0;
$TRUE               = 1;
$NO_CHECK_REQUIRED  = $FALSE;
$MULT_MGDHANDLES    = $FALSE;
 
#Attribute Names
$ALWDNODE           = "AllowedNode";
$NOMINALST          = "NominalState";
$PRIORITY           = "Priority";
$MBRLTN             = "MemberLocation";
$EXCLDLST           = "ExcludedList";
 
$MGDRSRC            = "ManagedResource";
$MBROF              = "MemberOf";
$MNDTRY             = "Mandatory";
 
$RLTSHP             = "Relationship";
$CNDTN              = "Conditional";
$TRGT               = "Target";
$SRSCE              = "Source";
 
$SLTPLCY            = "SelectFromPolicy";
$MBRSHP             = "Membership";
$MINNSSRY           = "MinimumNecessary";
 
# Relationship Constants
$COLLOCATED         = 1;                          # Collocated relationship
 
 
# Policies Constants
$ANY                = 0;                          # Any Policy
$ORDERED            = 1;                          # Ordered Policy
$ROUNDROBIN         = 2;                          # Round Robin Policy

 
our $DTYPE          = "";
our $MCLASS         = "";
 
our $ONLINE         = 0;                          # Nominal State - Online
our $OFFLINE        = 1;                          # Nominal State - Offline
#our $AUTO_MODE     = 1;                          # Automated Mode
our $NONE           = 0;                          # No location relationship
our $PR_LOW         = 0;                          # Lower limit for priority
our $PR_HIGH        = 200;                        # Higher limit for priority
 
#Constants
our $MIN_LOW        = 0;                          # MinimumNecessary Low limit
our $MIN_HIGH       = 100;                        # MinimumNecessary High limit
 
# Equivalency Constants
our $ANY_STR        = "ANY";                      # Any policy
our $ORDERED_STR    = "ORDERED";                  # Ordered policy
#our $ROUNDROBIN_STR= "R";                        # RoundRobin policy

# For SAMREQ
our $CURRENT_ACTIVE = "Active";
our $INACTIVE       = "InActive";
our $REMOVE_DONE    = "Done";
our $WAITING        = "Waiting";
our $None           = "None";
our $LOW            = "low";
our $HIGH           = "High";
our $FORCE          = "Force";
our $START          = "start";
our $STOP           = "stop";
our $MOVE           = "move"; 
our $CANCEL         = "cancel";
our $LOCK           = "lock";
our $UNLOCK         = "unlock";
our $MOVECANCEL     = "movecancel";
our $STARTOVR       = "startovr";
our $STOPOVR        = "stopovr";
our $Current_Active = 0x00000001;
our $InActive       = 0x00000000;
our $Remove_Done    = 0xffffffff;
our $Start          = 0;
our $Stop           = 1;
our $Move           = 2;
our $Cancel         = 3;
our $Lock           = 4;
our $Unlock         = 5;
our $MoveCancel     = 6;
our $StartOvr       = 7;
our $StopOvr        = 8;
our $low            = 0;
our $high           = 1;
our $force          = 2;

# DESIRED STATE
our $DS_NULL         = 0;         # problem: state is currently undefined
our $DS_ONLINE       = 1;         # user configured resource to be online
our $DS_OFFLINE      = 2;         # user configured resource to be offline
our $DS_FORCE_OFFLINE= 4;         # resource is requested to stopped immediately

# COMPOUND STATE
our $CS_NULL                 = 0; # problem: state is currently undefined
our $CS_PROBLEM              = 1; # problem: 
our $CS_DENIED               = 2; # problem: automation not allowed
our $CS_INHIBITED            = 4; # problem: depend resources not satisfactory
our $CS_AWAITING_AUTOMATION  = 8; # automation in progress
our $CS_IN_AUTOMATION        = 16;# automation in progress
our $CS_DEGRADED             = 32;# problem:
our $CS_SATISFACTORY         = 64;# requested state meats the current state


# OBSERVED STATE
our $OS_NULL                 = 0;    # problem: state is currently undefined
our $OS_UNKNOWN              = 1;    # problem: state not yet detected
our $OS_SYSTEM_GONE          = 2;    # problem: connection to system lost
our $OS_OFFLINE              = 4;    # resource is currently offline
our $OS_FAILED               = 8;    # problem: resource can?t be started
our $OS_PENDING_ONLINE       = 256;   # resource is starting
our $OS_ONLINE               = 512;   # resource is currently online
our $OS_DEGRADED             = 1024;  # problem: 
our $OS_STUCK_ONLINE         = 2048;  # problem: resource can?t be stopped
our $OS_PENDING_OFFLINE      = 4096;  # resource is stopping
our $OS_WAS_ONLINE           = 8192;  # problem: connection to resource lost
our $OS_INELIGIBLE           = 16384; # problem: SA_STANDBY

# BINDING STATE
our $BS_NULL            = 0;  # problem: state is currently undefined
our $BS_UNBOUND         = 1;  # resource is currently not dedicated to a system
our $BS_BOUND           = 2;  # resource is currently dedicated to a system
our $BS_UNWANTED        = 4;  # resource is not in use
our $BS_UNBINDABLE      = 8;  # configuration is incorrect
our $BS_SACRIFICED      = 16; # no system available to comply with configuration
our $BS_SACRIFICIAL     = 32; # no system available to comply with configuration
our $BS_WAITING         = 64; # automation in progress



# AUTOMATION STATE
our $AS_NULL           = 0;  # problem: state is currently undefined
our $AS_UNKNOWN        = 1;  # problem: state not yet detected
our $AS_SYSTEM_GONE    = 2;  # problem: the system is currently not available
our $AS_IDLE           = 4;  # no automation in progress
our $AS_ORDERED        = 8;  # automation in progress
our $AS_BUSY           = 16; # automation in progress
our $AS_DENIED         = 32; # problem: automation is not allowed
our $AS_PROBLEM        = 64; # problem: automation has a problem
our $AS_INTERNAL       = 128;# automation in progress


# CONTROL STATE
our $SS_NULL             = 0;  # state is currently undefined
our $SS_STARTABLE        = 1;  # the resource is startable
our $SS_NOT_STARTABLE    = 2;  # the resource is not startable
our $SS_START_INHIBITED  = 4;  # start dependency is not satisfactory
our $SS_DENIED           = 8;  # automation is not allowed
our $SS_STOP_INHIBITED   = 16; # stop dependency is not satisfactory
our $SS_NOT_CONTROLLABLE = 32; # resource is not controllable
our $SS_NODE_EXCLUDED    = 64; # node is excluded
our $SS_NODE_EX_NOT_CONT = 128;# node is excluded and resource not controllable
our $SS_REF_BROKEN       = 256;# resource reference broken (reserved for e2e)
our $SS_REF_ERROR        = 512;# resource reference error  (reserved for e2e)
our $SS_NRE              = 1024;# non recoverable error, manual reset required


# HEALTH STATE
#our $HS_NotApplicable    = 0;  # Status Health is not supported
#our $HS_Unknown          = 10; # The resource did not report a health status
#our $HS_Normal           = 20; # The resource does perform well
#our $HS_Warning          = 30; # the resource has a small performance problem
#our $HS_Minor            = 40; # The resource has a minor performance problem
#our $HS_Critical         = 50; # The resource has a critical performance problem
#our $HS_Fatal            = 60; # the resource does not perform


# HEALTH STATE
our $HS_NULL             = 0;  # problem: status is currently undefined
our $HS_SYSTEM_GONE      = 1;  # problem: the system is currently not available
our $HS_Unknown          = 2; # The resource did not report a health status
our $HS_NotApplicable    = 4;  # Status Health is not supported
our $HS_Normal           = 20; # The resource does perform well
our $HS_Warning          = 30; # the resource has a small performance problem
our $HS_Minor            = 40; # The resource has a minor performance problem
our $HS_Critical         = 50; # The resource has a critical performance problem
our $HS_Fatal            = 60; # the resource does not perform

# Move Status
our $MV_NULL             = 0x00000000;
our $MV_NOT_SUPPORTED    = 0x00000001;
our $MV_NONE             = 0x00000002;
our $MV_PREPARING        = 0x00000004;
our $MV_EXECUTING_STOP   = 0x00000008;
our $MV_CANCELING        = 0x00000010;
our $MV_EXECUTING_START  = 0x00000020;
our $MV_EXECUTING_BKOUT  = 0x00000040;
our $MV_COMPLETING       = 0x00000080;

# $A1 Start
# EVENT SUBSCRIPTION
#our $ES_FA_CONFIG           = 1;
#our $ES_FA_STATUS           = 2;
#our $ES_FI_NONE             = 0;
#our $ES_FI_INITIAL          = 1;
# $A1 End

our $Key                 = "%#$&&";
#--------------------------------------------------------------------#
# Exported Subroutines (with @EXPORT_OK, -> on demand).              #
#--------------------------------------------------------------------#

#--------------------------------------------------------------------#
# process_input_data - process the attr=value pairs that are used to #
#                      define this resource and were input by the    #
#                      user on the command line via an input file.   #
#                                                                    #
# Parameters:                                                        #
#   $Opt_File_Input   input   True - input should come from file.    #
#                             False - input should come from command #
#                             line.                                  #
#   $filename         input   Name of file if $Opt_File_Input = TRUE #
#   %$PrsAttrDef      input   Reference to complex hash of           #
#                             persistent attribute definitions.      #
#   %$SDataArgDef     input   Reference to complex hash of command   #
#                             arguments definitions for define.      #
#   @$r_cmdline       input   Reference to attr=value pairs via      #
#                             command line and ARGV.                 #
#                                                                    #
# Return:                                                            #
#   $rc                       return code.                           #
#   $RsrcAttrData             reference to list/array of resources   #
#                             and each resources attr=value pairs.   #
#   $rLoRsrcArgData           reference to list/array of resources   #
#                             and each resources arg=value pairs.    #
#                                                                    #
# Global References:                                                 #
#   None.                                                            #
#--------------------------------------------------------------------#
sub process_input_data
{
my $resource        = shift @_;
my $filename        = shift @_;
my %HoPAttrDefs     = ();               # Hash of Persistent Attribute
                                        # definitions
my @LoPAttr         = ();               # Ordered list of Pers Attr
my %HoSDAttrDefs    = ();
my %HoSDArgDefs     = ();               # Hash of Command SD Arguments
                                        # element definitions
my @LoSDArgs        = ();               # Array of SD Cmd Arg Elements
                                        # (type, value) ordered by
                                        # element id.
my @LoSDArgNames    = ();
my @mkrsrcapi_parms = ();               # parameters to send to mkrsrcapi
 
my %HoNLSData       = ();
my $badrc           = 0;
 
my $req_properties  = $RMC_RSRC_PATTR_REQD_FOR_DEFINE | $RMC_RSRC_PATTR_OPTION_FOR_DEFINE;
my @req_attributes  = ();
my $req_attr_stanza = "PersistentResourceAttributes";
my $req_arg_stanza  = "PersistentResourceArguments";
my $rc              = 0;
my $element;
my $RsrcAttrData;
my $rLoRsrcArgData;
my $new_resource;
my $rHoPAttr;
my $new_cmd_args;

# Disable quotes    
$ENV{'CT_CLI_QUOTE_STRING'}  = 0;  
 
# Get the persistent attribute definitions for this resource class
# and build a hash indexed using the persistent attribute program name
# that will allow easy access to each attributes id, data type
# and property definitions.
# The resource must already have been defined for an instance to
# be defined/created.
$rc = get_p_attr_defs_api($resource, 0, $req_properties,
    \@req_attributes, \@LoPAttr, \%HoPAttrDefs);
($rc == 0) || error_exit($rc);
 
my $data;
 
# Check if any of the Attributes are SDs, if they are required or
# optional for define (properties) then build HoSDAttrDefs
$rc = get_sd_defs($resource, \%HoPAttrDefs, \%HoSDAttrDefs);
($rc == 0) || error_exit($rc);
 
# Get the define command SD argument definitions for this resource
# class. The returned hash level 1 key will be the SD element name.
$rc = get_arg_defs_api($resource, "", "define", 1, \%HoSDArgDefs,
                       \@LoSDArgNames);
($rc == 0) || error_exit($rc);
 
 
 
($rc, $RsrcAttrData) = process_input_file($filename,$req_attr_stanza);
if ($rc != 0) {
    # Print Error processing input file msg
    # process_input_file will write a more detailed error message
    return(CHARM_CLI_USER_ERROR);
}
# If there are defined required command arguments get those too.
# but args are optional so set optional parameter 78199
if (scalar keys(%HoSDArgDefs) > 0) {
    ($rc, $rLoRsrcArgData) = process_input_file($filename, $req_arg_stanza, 1);
    if ($rc != 0) {
       # process_input_file will write a more detailed error message
        return(CHARM_CLI_USER_ERROR);
    }
}
 
if ($Verbose) {
    my ($attribute, $value, $entry, $row_header);
    foreach $entry (@$RsrcAttrData) {
        $row_header = $entry->[0];
        foreach $element (@{$entry->[1]}) {
            $attribute = $element->[0];
            $value = $element->[1];
        }
    }
    foreach $entry (@$rLoRsrcArgData) {
        $row_header = $entry->[0];
        foreach $element (@{$entry->[1]}) {
            $attribute = $element->[0];
            $value = $element->[1];
        }
    }
}
 
# If there are command arguments specified, then there must be
# one set of arguments for each set of attributes
if ((defined $rLoRsrcArgData && scalar(@$rLoRsrcArgData) > 0) && (scalar(@$RsrcAttrData) != scalar(@$rLoRsrcArgData))) {
    printCEMsg("EMsgCHARMcliMismatchAttrArg");
    return(CHARM_CLI_USER_ERROR);
}
 
($rc == 0) || error_exit($rc);
 
# Merge the attr=value pairs you got from the user with the
# resources actual attribute definitions to build a Hash of
# Persistent Attributes which contains the equivalent data as
# the mc_attribute_t structure ({at_name} {at_dtype} {at_value})
# The data you need to actually define the resource - also
# check that the user supplied values for all the required
# attributes
foreach $new_resource (@$RsrcAttrData) {
    # re-initialize all
    $RGrp                = "";
    @NodeNameList        = ();
    $NO_CHECK_REQUIRED   = $FALSE;
    $MULT_MGDHANDLES     = $FALSE;
   ($rc, $rHoPAttr) = build_resource($resource, $new_resource, \%HoPAttrDefs, \%HoSDAttrDefs, \%HoNLSData);
   if ($rc != 0) {
      if (!$badrc) { $badrc = $rc; }
      next;
   }
   # Process the command arguments if any were specified.
   if (defined @$rLoRsrcArgData && scalar keys(%HoSDArgDefs) > 0) {
      $new_cmd_args = shift (@$rLoRsrcArgData);
     ($rc, @LoSDArgs) = build_cmd_arg_sd_api($resource, $new_cmd_args, \%HoSDArgDefs);
      if ($rc != 0) {
          if (!$badrc) { $badrc = $rc; }
              next;
          }
   }
 
#      # If running in Verify mode, skip to next resource
      #$Opt_Verify && next;
 
      # Build parameters for mkrsrc-api command
 
  #TODO: setup_api for all commands like mkrsrc,chrsrc.
      @mkrsrcapi_parms = setup_mkrsrcapi(\@mkrsrcapi_parms, $resource,$rHoPAttr, \@LoSDArgs);
}   # end foreach $new_resource
my $test = scalar @mkrsrcapi_parms;
unless(scalar(@mkrsrcapi_parms) >0){
     $rc = $badrc;
}else {
     $rc = 0;
}

return ($rc,$badrc,\@mkrsrcapi_parms);
}   # end process_input_data

#--------------------------------------------------------------------#
# get_sd_defs   -   Will get this resource's persistent attribute    #
#                   SD definitions and build a hash indexible via the#
#                   attribute program name with the attributes       #
#                   element names and types stored as data.          #
#                                                                    #
# Parameters:                                                        #
#   $resource       input   name of the resource that we wish to     #
#                             create an instance of.                 #
#   %$PrsAttrDef    input   Reference to the hash of Persistent      #
#                             attribute definitions.                 #
#   %$SDataAttrDef   in/out  Reference to the hash of persistent     #
#                             SD attribute element definitions.      #
# Return                                                             #
#   $rc                       return code.                           #
#                                                                    #
# Global References:                                                 #
#   None.                                                            #
#--------------------------------------------------------------------#
sub get_sd_defs
{
my ($resource, $PrsAttrDef, $SDataAttrDef) = @_;
my $rc            = 0;
my @sd_attr_names = ();
my $properties    = "";
my $attr_name     = "";
my $dtype         = "";


# first scan through the Hash of Persistent Attributes checking
# to see if any are SDs or SDArrays and their properties are
# required or optional for define.
my @pattr_names = keys %$PrsAttrDef;
 
foreach $attr_name (@pattr_names) {
    $dtype = $$PrsAttrDef{$attr_name}{at_dtype};
    $properties = $$PrsAttrDef{$attr_name}{at_properties};
 
    if ( (($dtype =~ /^CT_SD_PTR$/) || ($dtype =~ /^CT_SD_PTR_ARRAY$/)) &&
         (($properties =~ /reqd_for_define/) || ($properties =~ /option_for_define/)) )
    {
        # Add these SD attributes to array of all SD attr names
        push @sd_attr_names, $attr_name;
    }
}
 
# Need to make sure each of the SDs are defined and get various info
# associated with the each persistent resource SDs elements.
 
# If we found any persistent attributes that are SD get their
# definition from RMC
if (scalar(@sd_attr_names) > 0) {
 
    # Get the SD data and
    # Format the Query Definition Structured Data attributes
    # and elements into a form suitable for quick look up by
    # attribute name the for the element data_types.
    get_sd_defs_api($resource, 0, \@sd_attr_names, $SDataAttrDef);
 
}
 
return($rc);
}   # end get_sd_defs
 
#--------------------------------------------------------------------#
# build_resource - function to build up the hash of persistent attr  #
#                  to be used in defining the resource. Merging the  #
#                  {at_name}, {at_value}, {at_dtype} all into one    #
#                  structure and validating the input data as its    #
#                  processed.                                        #
#                                                                    #
# Parameters:                                                        #
#   $resource         input   Resource name.                         #
#   $rRsrcData        input   Reference to array of attr,value pairs.#
#   $PrsAttrDef       input   Reference to hash of all the required  #
#                             and optional attribute definitions     #
#                             for this resource.                     #
#   $SDataAttrDef     input   Reference to hash of all the required  #
#                             and optional SD attribute definitions  #
#                             for this resource.                     #
#   $rHoNLSData       input   Reference to hash of NLS Data.         #
#                             For example:                           #
#                             MessageMapPath => </usr/sbin/rsct/..>  #
#                             MessageSet     => mkrsrc               #
#                             MessageCat     => mccli.cat            #
#                             PersistentResourceAttributes = %hash   #
#                             of attribute names that need to be     #
#                             translated.                            #
#                                                                    #
# Return:                                                            #
#   $rc                       return code.                           #
#   $rHoPAttr                 Reference complex hash of persistent   #
#                             attributes including their values.     #
#                                                                    #
# Global References:                                                 #
#   None.                                                            #
#--------------------------------------------------------------------#
sub build_resource
{
my ($resource, $rRsrcData, $PrsAttrDef, $SDataAttrDef,$rHoNLSData) = @_;
 
my %HoPAttr             = ();
my @required_attributes = ();
my $new_attr            = "";
my $dtype               = "";
my $badrc               = 0;
my $attr_name           = "";
my $attr_value          = "";
my %elements            = ();
my $data                = "";
my $tmp_attr_value      = ""; 
my $memberofcount       = 0;
my $FOUNDMBROF          = $FALSE;
my $MCLASS              = "";

my %HoPAttrDefs         = %$PrsAttrDef;
 


PROCESSALLATTR:
# Process all of the attr value pairs for this resource. Attr
# value pairs should come before Arg value pairs on the command line.
foreach $new_attr (@{$rRsrcData->[1]}) {
   
    $attr_name = $new_attr->[0];
    # first check to make sure this is either a valid attribute name
    # or a valid command argument name.
    if (!defined($HoPAttrDefs{$attr_name})) {
        printCEMsg("EMsgCHARMcliAttrNotDefForSet", $attr_name, $resource, $rRsrcData->[0]);
        $badrc = CHARM_CLI_USER_ERROR;
        next;                   # continue validating rest of input
    }
 
    # next check to make sure the value is of the right type
    # SDs require some special handling...
    $dtype = $HoPAttrDefs{$attr_name}{at_dtype};
    $DTYPE = $dtype;
    if ( ($dtype =~ /^CT_SD_PTR$/) || ($dtype =~ /^CT_SD_PTR_ARRAY$/) ) {
        @r_sd_element_dtypes = get_sd_element_dtypes($SDataAttrDef,$attr_name);
        ($rc, $attr_value) = convert_input_value_api($dtype,$new_attr->[1], \@r_sd_element_dtypes);
    }
    else {
        if($resource eq $RSRCMGD){
            unless($FOUNDMBROF){
               if($attr_name eq $MBROF){
                    $FOUNDMBROF = $TRUE;
               } else {
                    next;
               }
            } else{
               if($attr_name eq $MBROF){
                   next;
               }
            }                  
        }
       
        # check if value is correct
        $tmp_attr_value = $new_attr->[1];
        unless(($attr_name eq $MGDRSRC)||($attr_name eq $SRSCE)||($attr_name eq $TRGT)||($attr_name eq $MBRSHP)||($attr_name eq $ALWDNODE)||($attr_name eq $EXCLDLST)){
           ($rc, $attr_value) = convert_input_value_api($dtype, $new_attr->[1]);
        } else {
           $tmp_attr_value =~ s/"//g;
           if(($attr_name eq $TRGT)||($attr_name eq $MBRSHP)){
               $tmp_attr_value =~ s/\{//g;
               $tmp_attr_value =~ s/\}//g;
           }
           if($tmp_attr_value =~ /^(0x|\d+)\d*/) {
 
               ($rc, $attr_value) = convert_input_value_api($dtype, $new_attr->[1]);
           } else {
               $attr_value = $new_attr->[1];
           }
        }
        #if Managed resource, Target, Membership, or AllowedNode check to see if it is 
        # not a valid string
        if ($rc != 0) {
            printCEMsg("EMsgCHARMcliBadAttrValue", $attr_name, $new_attr->[1]);
            if ($badrc == 0) {$badrc = $rc; }
            next;
        }
        unless($tmp_attr_value =~ /^(0x|\d+)\d*/) {
            ($rc, $attr_value) = &translate_attr_value($attr_name,$attr_value);
        }
    }
    if ($rc != 0) {
        printCEMsg("EMsgCHARMcliBadAttrValue", $attr_name, $new_attr->[1]);
        if ($badrc == 0) {$badrc = $rc; }
        return($badrc, \%HoPAttr);
    }
    %elements = ();
    $elements{at_name} = $attr_name;
    $elements{at_dtype} = $HoPAttrDefs{$attr_name}{at_dtype};
    $elements{at_value} = $attr_value;
    # save original SD value
    if ( ($dtype =~ /^CT_SD_PTR$/) || ($dtype =~ /^CT_SD_PTR_ARRAY$/) ) {
       $elements{at_SD_value} = $new_attr->[1];
    }
 
    $HoPAttr{$attr_name} = { %elements };
    if (($FOUNDMBROF)&&($memberofcount < 1)) {
        ++$memberofcount;
        goto PROCESSALLATTR; 
    }
}
 
# Make sure that all of the required attributes are being
# defined.
foreach $attr_name (@required_attributes) {
    if (!defined($HoPAttr{$attr_name})) {
        printCEMsg("EMsgCHARMcliMissingReqAttr", $attr_name, $resource);
        $badrc = CHARM_CLI_USER_ERROR;
    }
}
 
# Translate any of the Persistent Attributes that were listed in
# the NLSTranslation Stanza PersistentResourceAttributes keyword
#if (defined $rHoNLSData->{PersistentResourceAttributes}) {
#           $rc = translate_attr_values(\%HoPAttr, $SDataAttrDef,
#               $rHoNLSData);
#       }
 
return($badrc, \%HoPAttr);
}   # end build_resource
 
 
#--------------------------------------------------------------------#
# translate_attr_values - function to translate persistent attribute #
#                         values to recognizable attribute types and #
#                         values. Will return a bad return code if   #
#                         not translatable or recognized.            #
#                                                                    #
# Parameters:                                                        #
#   $attr_name        input   Name of the attribute to be translated #
#                             and verified.                          #
#   $attr_value       input   Actual value of the attribute passed   #
#                             for translation and verification.      #
# Return:                                                            #
#   $rc                       return code.                           #
#   $new_value                Translated value of the attribute.     #
#                                                                    #
# Global References:                                                 #
#   None.                                                            #
#--------------------------------------------------------------------#
sub translate_attr_value{
 
my ($attr_name,$attr_value) = @_;
my $rc                     = 0;
my $new_value;


 
SWITCH: {
     if ($attr_name =~ /^$NOMINALST/i) {
         ($rc,$new_value) = &VerifyNominalState($attr_value);
         #($rc == 0) ||(return $rc);
         last SWITCH;
     }
     if ($attr_name =~ /^$PRIORITY/i) {
         ($rc,$new_value) = &VerifyPriority($attr_value);
         #($rc == 0) ||(return $rc);
         last SWITCH;
     }
     if ($attr_name =~ /^$EXCLDLST/i) {
        ($rc,$new_value) = &VerifyExcludedlist($attr_value);
         last SWITCH;
     }
     if ($attr_name =~ /^$MBROF/i) {
         $RGrp = $attr_value;
         ($rc,$new_value) = &VerifyMemberOf($attr_value);
         $new_value = $attr_value;
         last SWITCH;
     }
     if ($attr_name =~ /^$MBRLTN/i) {
         ($rc,$new_value) = &VerifyMemberLocation($attr_value);
         #($rc == 0) ||(return $rc);
         last SWITCH;
     }
     if ($attr_name =~ /^$ALWDNODE/i) {
         ($rc,$new_value) = &VerifyAllowedNode($attr_value);
         #($rc == 0) ||(return $rc);
         last SWITCH;
     }
     if ($attr_name =~ /^$MNDTRY/i) {
         ($rc,$new_value) = &VerifyMandatory($attr_value);
         #($rc == 0) ||(return $rc);
         last SWITCH;
     }
     if ($attr_name =~ /^$RLTSHP/i) {
        ($rc,$new_value) = checkifvalidrelationship($attr_value);
         last SWITCH;
     }
     if ($attr_name =~ /^$CNDTN/i) {
        ($rc,$new_value) = checkifvalidcondition($attr_value);
         last SWITCH;
     }
     if ($attr_name =~ /^$MINNSSRY/i) {
        ($rc,$new_value) = &VerifyMinNecessary($attr_value);
         last SWITCH;
     }
     if ($attr_name =~ /^$SLTPLCY/i) {
        ($rc,$new_value) = &VerifyPolicy($attr_value);
         last SWITCH;
     }
     if ($attr_name =~ /^$MGDRSRC/i) {
        ($rc,$new_value) = &VerifyManagedResource($attr_value);
         last SWITCH;
     }
     if ($attr_name =~ /^$SRSCE/i) {
        ($rc,$new_value) = &VerifySource($attr_value);
         last SWITCH;
     }
     if ($attr_name =~ /^$TRGT/i) {
        ($rc,$new_value) = &VerifyTarget($attr_value);
         last SWITCH;
     }
     if ($attr_name =~ /^$MBRSHP/i) {
        ($rc,$new_value) = &VerifyMembership($attr_value);
         last SWITCH;
     }
     if ($attr_name =~ /^$MBRCLASS/i) {
         $MCLASS = $attr_value;
         $new_value = $attr_value;
         last SWITCH;
     }
     $new_value = $attr_value;
}   # end switch
 
return($rc, $new_value);
} #end translate_attr_value

#--------------------------------------------------------------------#
# VerifyMemberOf -    Will check the validity of the MemberOf attrib-#
#                     ute of managed resources.                      #
#                                                                    #
# Parameters:                                                        #
#   $member     input MemberOf attribute value.                      #
#                                                                    #
# Return:                                                            #
#   $rc               return code.                                   #
#   $member           Valid MemberOf attribute value.                #
#                                                                    #
# Global References:                                                 #
#   None.                                                            #
#--------------------------------------------------------------------#
sub VerifyMemberOf
{
 
my ($member)         = @_;
my $rc               = 0;
my $alnode           = "";
my @resource_handles = ();
my $Opt_Handles      = $FALSE;
 
# command syntax to find allowed nodes
my $act_attribute       = "-a AllowedNode -o $RSRCGRP" ."::\"$member\"";
 
# check for Resource Groups
($allowednode,@allowednode) = get_resource_attributes($Opt_Handles,$act_attribute,@resource_handles);
 
# get class name, resource name and allowednode
($class,$res,$alnode) = split("::",$allowednode);
# Check if resourceGroup exist
# If ResourceGroup and unless all nodes are allowed
# check if it an equivalency or node.
SWITCH:{
    if ($alnode eq ""){
        printCEMsg("EMsgCHARMcliResourceGroupDoesNotExist",$member);
        $rc = CHARM_CLI_NO_RSRC_FOUND;
        last SWITCH;
    }
    if($alnode eq $EQUIV_ALL){
        $NO_CHECK_REQUIRED = $TRUE;
        last SWITCH;
    }
   push @resource_handles, $alnode;
   (@NodeNameList) = allowednodeiswhat(@resource_handles);
} #end switch


return($rc,$member);
}

#--------------------------------------------------------------------#
# VerifyPolicy   -    Will check the validity of the policy for the  #
#                     equivalency.                                   #
#                                                                    #
# Parameters:                                                        #
#   $policy     input Equivalency policy value.                      #
#                                                                    #
# Return:                                                            #
#   $rc               return code.                                   #
#   $policy           Valid policy value.                            #
#                                                                    #
# Global References:                                                 #
#   None.                                                            #
#--------------------------------------------------------------------#
sub VerifyPolicy {
 
my ($policy)  = @_;
my $rc        = 0;
 
# Make sure policy is a number (hex, octal or decimal)
if ($policy =~ /^(0x|\d+)\d*/) {
    # Convert policy specified in hex or octal to decimal
    $policy = oct($policy) if $policy =~ /^0/;
 
    # Check if specified policy names or values are valid
    unless (($policy == $ANY)||($policy == $ORDERED)) {
        $rc = CHARM_CLI_BAD_OPERAND;
    }
} elsif (($policy =~ /^A$/i) ||($policy =~ /^$ANY_STR$/i)) {       # $A0 $A2   
     $policy = $ANY;
} elsif (($policy =~ /^O$/i) ||($policy =~ /^$ORDERED_STR$/i)) {   # $A0  $A2
     $policy = $ORDERED;
#} elsif (($policy =~ /^R$/i) ||($policy =~ /^$ROUNDROBIN_STR$/i)) {
#     $policy = $ROUNDROBIN;
} else {
    $rc = CHARM_CLI_BAD_OPERAND;
}
 
return ($rc,$policy);
}

#--------------------------------------------------------------------#
# VerifyManagedResource  - Will check the validity of the managed    #
#                          resource.                                 #
#                                                                    #
# Parameters:                                                        #
#   $resource     input    Managed Resource input format.            #
#                                                                    #
# Return:                                                            #
#   $rc               return code.                                   #
#   $resource         Valid managed resource handles.                #
#                                                                    #
# Global References:                                                 #
#   None.                                                            #
#--------------------------------------------------------------------#
sub VerifyManagedResource {
 
my ($resource)  = @_;
my $rc        = 0;
my %member_resources = ();
my ($class,$resources);
my $i;

my $tmp_attr_value = $resource;
$tmp_attr_value =~ s/"//g;
unless($tmp_attr_value =~ /^(0x|\d+)\d*/) {
    my (@resources) = split(/ /,$resource);

    if (scalar @resources > 0) {
      # transfer resource class and resources to hash
       for($i=0;$i<=$#resources;$i++) {
          ($class,$resources) = split(/:/,$resources[$i],2);
          if(!defined $resources) {
             printCEMsg("EMsgCHARMcliMissingResources",$class);
             $rc = CHARM_CLI_BAD_OPERAND;
          }
          push (@{$member_resources{$class}},$resources);
       }
    }else {
       $rc = CHARM_CLI_BAD_OPERAND;
    }
    if($rc==0){
      ($rc,$resource) = get_mgdrsrchandles(%member_resources);
      # convert the resources and class to resource handles if possible
      # if it fails and set rc to failed
    }
}

return ($rc,$resource);
}

#--------------------------------------------------------------------#
# VerifyMembership  - Will check the validity of the Membership      #
#                     attribute value for Equivalency.               #
#                                                                    #
# Parameters:                                                        #
#   $membership   input  Raw Membership  attribute value.            #
#                                                                    #
# Return:                                                            #
#   $rc               return code.                                   #
#   $members          Valid member resource handle list.             #
#                                                                    #
# Global References:                                                 #
#   None.                                                            #
#--------------------------------------------------------------------#
sub VerifyMembership {
 
my ($membership)  = @_;
my $rc        = 0;
my $member_string = "";
my $members      = "";

$membership =~ s/"//g;
$membership =~ s/\{//g;
$membership =~ s/\}//g;
unless($membership =~ /^(0x|\d+)\d*/) {
   #my ($resource_class,$resource) = split(/:/,$membership,2);
   if(!defined $membership){
      printCEMsg("EMsgCHARMcliMissingResources",$MCLASS);
      $rc = CHARM_CLI_BAD_OPERAND;
   }
   if($rc==0){
      $main::Opt_Resources = $TRUE;
      my @resources = split(/,/,$membership);
      if(scalar @resources > 0) {
         # parse command line to generate resources
         my ($resource_opts,@actual_resources) = parse_resources($MCLASS,$member_string,@resources);
         # Get resource handles
         my ($act_rsrce,$resource_handles) = get_resourcehandles($Opt_SelectString,$resource_opts);

         #copy actual values from ref. to hashes
         my %act_resources     = %$act_rsrce;
         my @resource_handles = @$resource_handles;
         my $count =0;
         foreach $resource (@resource_handles)
         {
            unless($count == 0){
               $members .= "," . $resource;
               ++$count;
               next;
            }
            $members =  "{" . $resource;
            ++$count;

         }
         if( $count > 0){
            $members .=  "}";
            ($rc, $members) = convert_input_value_api($DTYPE, $members);
         } else {
            printCEMsg("EMsgCHARMcliNoResourcesExists");
            $rc = CHARM_CLI_BAD_OPERAND;
         }
     } else {
           $members = "{}";
     }

   }
}
return ($rc,$members);
}

#--------------------------------------------------------------------#
# VerifySource     -  Will check the validity of the Source resources#
#                     in a relationship.                             #
#                                                                    #
# Parameters:                                                        #
#   $source       input  Source resources input data.                #
#                                                                    #
# Return:                                                            #
#   $rc               return code.                                   #
#   $source           Source resoure handle with DELIMITTERS.        #
#                                                                    #
# Global References:                                                 #
#   None.                                                            #
#--------------------------------------------------------------------#
sub VerifySource {
 
my ($source)  = @_;
my $rc        = 0;
my $source_string = "";

my $tmp_attr_value = $source;
$tmp_attr_value =~ s/"//g;
unless($tmp_attr_value =~ /^(0x|\d+)\d*/) {
      ($rc,$source) = get_sourcehandles($source,$source_string);
}
$source =~ s/"//g;
return ($rc,$source);
}

#--------------------------------------------------------------------#
# VerifyTarget     -  Will check the validity of the Target resources#
#                     in a relationship.                             #
#                                                                    #
# Parameters:                                                        #
#   $target       input  Target resources input data.                #
#                                                                    #
# Return:                                                            #
#   $rc               return code.                                   #
#   $target_opts      Target resource handles with DELIMITTERS.      #
#                                                                    #
# Global References:                                                 #
#   None.                                                            #
#--------------------------------------------------------------------#
sub VerifyTarget {
 
my ($target)  = @_;
my $rc        = 0;
my %member_resources = ();
my ($class,$resources);
my $i;
my ($target_opts,@act_trgtresources);

$target_opts  =  $target;

$target =~ s/"//g;
$target =~ s/\{//g;
$target =~ s/\}//g;
unless($target =~ /^(0x|\d+)\d*/) {

# parse command line to generate new target resources
my %target_rsrc = parse_targetresources($Opt_Target,$target,$target_string,$Opt_Target_Select);
#my %target_rsrc = parse_targetresources($Opt_Target,$tmp_attr_value,$target_string,$Opt_Target_Select);
 
# If no targets specified exit
unless (scalar keys(%target_rsrc) > 0) {
    $rc = CHARM_CLI_NO_RSRC_FOUND;
    return ($rc,$target);
}
 
# Generate target operands for lsrsrcinfo command
($target_opts,@act_trgtresources) = gen_operands($Opt_Target_Select,%target_rsrc);
 
# Get target resource handles
my %act_resources = get_resourcehandles($main::Opt_Target_Select,$target_opts);
 
 
# If none of the target resources exists
if ($main::Opt_AllResourcesMissing) {
    $rc = CHARM_CLI_NO_RSRC_FOUND;
    return ($rc,$target);
}
 
# Target resource handles
my @target_handles = keys %act_resources;

my $count =0;
foreach $target (@target_handles)
{
   unless($count == 0){
    $target_opts .= "," . $target;
    ++$count;
    next;
   }
   $target_opts =  "{" . $target;
   ++$count;
   
}
if( $count > 0){ 
   $target_opts .=  "}";
   ($rc, $target_opts) = convert_input_value_api($DTYPE, $target_opts);
}
# Prepare the mkrel operand for mkrsrc command
#$target_opts  = gen_new_attrib_list("Target",$opts,@target_handles);
}

return ($rc,$target_opts);
}

#--------------------------------------------------------------------#
# VerifyMandatory  -  Will check the validity of the Mandatory       #
#                     attribute value for managed resources.         #
#                                                                    #
# Parameters:                                                        #
#   $mandatory    input  Raw Mandatory attribute value.              #
#                                                                    #
# Return:                                                            #
#   $rc               return code.                                   #
#   $mandatory        Valid mandatory value.                         #
#                                                                    #
# Global References:                                                 #
#   None.                                                            #
#--------------------------------------------------------------------#
sub VerifyMandatory {
 
my ($mandatory)  = @_;
my $rc        = 0;
 
# Make sure mandatory is a number (hex, octal or decimal)
if ($mandatory =~ /^(0x|\d+)\d*/) {
    # Convert mandatory specified in hex or octal to decimal
    $mandatory = oct($mandatory) if $mandatory =~ /^0/;
 
    # Check if specified mandatory names or values are valid
    unless (($mandatory == $TRUE)||($mandatory == $FALSE)) {
        $rc = CHARM_CLI_BAD_OPERAND;
    }
} elsif (($mandatory =~ /^T$/i) ||($mandatory =~ /^TRUE$/i)) {     # $A0 $A2
     $mandatory = $TRUE;
} elsif (($mandatory =~ /^F$/i) ||($mandatory =~ /^FALSE$/i)) {    # $A0 $A2
     $mandatory = $FALSE;
} else {
    $rc = CHARM_CLI_BAD_OPERAND;
}
 
return ($rc,$mandatory);
}

#--------------------------------------------------------------------#
# VerifyMinNecessary -   Will check the validity of the Minimum Nece-#
#                        ssary attribute value for equivalency.      #
#                                                                    #
# Parameters:                                                        #
#   $min_necessary    input   Raw Minimum Necessary attribute value. #
#                                                                    #
# Return:                                                            #
#   $rc               return code.                                   #
#   $min_necessary    Valid minimum necessary value.                 #
#                                                                    #
# Global References:                                                 #
#   None.                                                            #
#--------------------------------------------------------------------#
sub VerifyMinNecessary {
 
my ($min_necessary)  = @_;
my $rc        = 0;
 
   if ($min_necessary !~ /^(0x|\d+)\d*/) {
      $rc = CHARM_CLI_BAD_OPERAND;
   }
   # Convert min_necessary specified in hex or octal to decimal
   $min_necessary = oct($min_necessary) if $min_necessary =~ /^0/;

   # Check if specified min_necessary values are valid
   if (($min_necessary < $MIN_LOW)||( $min_necessary > $MIN_HIGH)) {
      $rc = CHARM_CLI_BAD_OPERAND;
   }
return ($rc,$min_necessary);
}

#--------------------------------------------------------------------#
# VerifyMemberLocation - Will check the validity of the MemberLocati-#
#                        on value for resource groups.               #
#                                                                    #
# Parameters:                                                        #
#   $location         input   Raw Member Location attribute value.   #
#                                                                    #
# Return:                                                            #
#   $rc               return code.                                   #
#   $location         Valid location value.                          #
#                                                                    #
# Global References:                                                 #
#   None.                                                            #
#--------------------------------------------------------------------#
sub VerifyMemberLocation {
 
my ($location)  = @_;
my $rc        = 0;
 
# Make sure location is a number (hex, octal or decimal)
if ($location =~ /^(0x|\d+)\d*/) {
    # Convert location specified in hex or octal to decimal
    $location = oct($location) if $location =~ /^0/;
 
    # Check if specified Location names or values are valid
    if ($location == $COLLOCATED) {
        $location = $COLLOCATED;
    } elsif ($location == $NONE) {
      $location = $NONE;
    } else {
        $rc = CHARM_CLI_BAD_OPERAND;
    }
} elsif ($location =~ /^COLLOCATED$/i) {                    # $A0 $A2
    $location = $COLLOCATED;
} elsif ($location =~ /^NONE$/i){                           # $A0 $A2
    $location = $NONE;
} else {
    $rc = CHARM_CLI_BAD_OPERAND;
}
 
return ($rc,$location);
}
 
#--------------------------------------------------------------------#
# VerifyPriority     - Will check the validity of the priority       #
#                      value for resource groups.                    #
#                                                                    #
# Parameters:                                                        #
#   $priority         input   Priority Value.                        #
#                                                                    #
# Return:                                                            #
#   $rc               return code.                                   #
#   $priority         Valid priority value.                          #
#                                                                    #
# Global References:                                                 #
#   None.                                                            #
#--------------------------------------------------------------------#
sub VerifyPriority {
 
my ($priority)  = @_;
my $rc        = 0;
 
# Make sure priority is a number (hex, octal or decimal)
if ($priority !~ /^(0x|\d+)\d*/) {
    $rc = CHARM_CLI_BAD_OPERAND;
    return($rc,$priority);
}
# Convert priorities specified in hex or octal to decimal
$priority = oct($priority) if $priority =~ /^0/;
 
# Check if priority is within limits
if (($priority < $PR_LOW)||( $priority > $PR_HIGH)) {
   $rc = CHARM_CLI_BAD_OPERAND;
}
return($rc,$priority);
}
 
#--------------------------------------------------------------------#
# VerifyAllowedNode  - Will check the validity of the Allowed Node   #
#                      value for resource groups.                    #
#                                                                    #
# Parameters:                                                        #
#   $allowed_node     input   Allowed Node or Equivalency Name.      #
#                                                                    #
# Return:                                                            #
#   $rc               return code.                                   #
#   $node_handle      Valid Allowed node resource handle.            #
#                                                                    #
# Global References:                                                 #
#   None.                                                            #
#--------------------------------------------------------------------#
sub VerifyAllowedNode {
 
my ($allowed_node) = @_;
my $node_handle;
my $rc        = 0;
 
if (($allowed_node eq $NULL)||($allowed_node eq $EQUIV_ALL)){
   $node_handle=$EQUIV_ALL;
   return($rc,$node_handle);
}

# Ignore any errors from module.
$main::Opt_IgnoreMissingNode = $TRUE; 
# To check if it is a node in the cluster.
$resource_class = $RSRCNODE;
if($main::Trace){
   print STDERR "$main::PROGNAME: Checking for valid Allowed Node\n";
}
($node_handle) = get_allowednode_handle($allowed_node,$resource_class);
 

if($node_handle eq "") {
  if($main::Trace){
    print STDERR "$main::PROGNAME: Checking for valid Equivalency as Allowed Node\n";
  }
  # To check if it is a node in the cluster.
  $resource_class = $RSRCEQU;
  ($node_handle) = get_allowednode_handle($allowed_node,$resource_class);
}
 
if($node_handle eq "") { $rc = CHARM_CLI_BAD_OPERAND; }
$node_handle =~ s/\"//g;  
return($rc,$node_handle);
}
 
#--------------------------------------------------------------------#
# VerifyNominalState - Will check the validity of the Nominal State  #
#                      value for resource groups.                    #
#                                                                    #
# Parameters:                                                        #
#   $nominal_state    input   Raw Nominal State value.               #
#                                                                    #
# Return:                                                            #
#   $rc               return code.                                   #
#   $nominal_state    Valid value of Nominal State.                  #
#                                                                    #
# Global References:                                                 #
#   None.                                                            #
#--------------------------------------------------------------------#
sub VerifyNominalState {
 
my ($nominal_state) = @_;
my $rc        = 0;
 
 # Make sure location is a number (hex, octal or decimal)
if ($nominal_state =~ /^(0x|\d+)\d*/) {
    # Convert location specified in hex or octal to decimal
    $nominal_state = oct $nominal_state if $nominal_state =~ /^0/;
    if ($nominal_state == $OFFLINE) {
       #$main::Opt_RG_Offline = $TRUE;             # offline specified
    } elsif ($nominal_state == $ONLINE) {
       #$main::$Opt_RG_Online = $TRUE;              # online specified
    } else {
       $rc = CHARM_CLI_BAD_OPERAND;
    }
} elsif ($nominal_state =~ /^ONLINE$/i) {         # $A0  $A2
    $nominal_state = $ONLINE;
    #$main::Opt_RG_Online = $TRUE;              # online specified
} elsif ($nominal_state =~ /^OFFLINE$/i){         # $A0  $A2
    $nominal_state = $OFFLINE;
    #$main::Opt_RG_Offline = $TRUE;             # offline specified
} else {
    $rc = CHARM_CLI_BAD_OPERAND;
}
return($rc,$nominal_state);
}
 
#--------------------------------------------------------------------#
# setup_mkrsrcapi - function to add a parameter specification to be  #
#   used later for mkrsrc-api.                                       #
#                                                                    #
# Parameters:                                                        #
#   $mkrsrcapi_parm   in/out  Name of the string variable that has   #
#                             any previous resource definition.      #
#   $rsrc_class       input   Name of the resource class to which we #
#                             want to define a new resource.         #
#   %$rHoAttr         input   Reference to complex hash of attribute #
#                             names and value pairs.                 #
#   @$rLoSDArgs       input   Reference to a list of of SD Command   #
#                             Arguments (if any).                    #
#                                                                    #
# Return:                                                            #
#   $rc                       return code.                           #
#                                                                    #
# Global References:                                                 #
#   Trace             input   Trace call & return of extension.      #
#   Verbose           input   Print newly defined rsrc handle.       #
#--------------------------------------------------------------------#
sub setup_mkrsrcapi
{
my ($mkrsrcapi_parm, $rsrc_class, $rHoAttr, $rLoSDArgs) = @_;
my $newparms= "";
my $newparms1= "";
my $tmpparms= "";
my $i=0;
my $j=0;
my $comma = "";
my $attr;
my $delstr = "";
my @rsrc_handles = ();
 
 
# format being created:
# ClassName[::<AttrName>::<AttrValue]...[::[::<ArgName>::<ArgValue>]...]
 
# start new parameter list with resource class
$newparms = $rsrc_class;

if($MULT_MGDHANDLES){
    $delstr .= "/" . $DELIMITER . "/";
   # TODO use Resource class to validate
    @rsrc_handles = split(/::/,$$rHoAttr{$MGDRSRC}{at_value}); 
    #@rsrc_handles = split($delstr,$$rHoAttr{$MGDRSRC}{at_value}); 
}

           

# add regular attributes and values
my @attr_list = keys %$rHoAttr;
foreach $attr (@attr_list) {
   if ( ( $$rHoAttr{$attr}{at_dtype} =~ /^CT_SD_PTR$/ ) ||
        ( $$rHoAttr{$attr}{at_dtype} =~ /^CT_SD_PTR_ARRAY$/ ) ) {
      $newparms .= $DELIMITER . $attr . $DELIMITER . $$rHoAttr{$attr}{at_SD_value};
  }
   elsif ( $$rHoAttr{$attr}{at_dtype} =~ /ARRAY/ ) {
      $tmpparms = "{";
      $i = scalar(@{$rHoAttr->{$attr}->{at_value}});
      for ($j=0; $j<$i; $j++){
          $tmpparms .= $comma . $rHoAttr->{$attr}->{at_value}[$j];
          $comma = ",";
      }
      $tmpparms .= "}";
      $comma = "";
 
      $newparms .= $DELIMITER . $attr . $DELIMITER . $tmpparms;

 
   }
   else {
      if(($attr eq $MGDRSRC)&&($MULT_MGDHANDLES)){
          next;
      }      
      $newparms .= $DELIMITER . $attr . $DELIMITER . $$rHoAttr{$attr}{at_value};
               
   }
}

         
# check for any null attribute values
# should be ok but mkrsrc-api doesn't like it now
$newparms =~ s/${DELIMITER}${DELIMITER}/${DELIMITER}''${DELIMITER}/g;
$newparms =~ s/${DELIMITER}$/${DELIMITER}''/;
 
$comma = "";
# process any command options (arguments)
if ($#{$rLoSDArgs} >=0) {
   # use double delimiters to show args next
   $newparms1 .= $DELIMITER;
   for (my $j=0; $j<=$#$rLoSDArgs; $j++) {
      if ( ${$$rLoSDArgs[$j]}{type} =~ /ARRAY/ ) {
         $tmpparms = "{";
         $i = scalar (@{$$rLoSDArgs[$j]->{value}});
         for (my $k=0; $k<$i; $k++){
             $tmpparms .= $comma . ${$$rLoSDArgs[$j]->{value}}[$k];
             $comma = ",";
         }
         $tmpparms .= "}";
         $comma = "";
 
         $newparms1 .= $DELIMITER . $$rLoSDArgs[$j]->{name} . $DELIMITER . $tmpparms;
 
      }
      else {
         $newparms1 .= $DELIMITER . $$rLoSDArgs[$j]->{name} . $DELIMITER . $$rLoSDArgs[$j]->{value};
      }
   }
}
 
# going to put double quotes around the whole thing so
# escape any inner quotes
#$newparms =~ s/\\/\\\\/g;
#$newparms =~ s/\"/\\\"/g;
$newparms = escape_chars($newparms);
#$newparms1 =~ s/\\/\\\\/g;
#$newparms1 =~ s/\"/\\\"/g;
$newparms1 = escape_chars($newparms1);
 
# append the new parameters to the existing one
if($MULT_MGDHANDLES){
   my $tmp_parms = " \"" . $newparms;
   my $count = 0;   

   foreach $handles (@rsrc_handles) {
      unless($count == 0) {
          $newparms .= $tmp_parms . $DELIMITER . $MGDRSRC . $DELIMITER . $handles . $newparms1;
      } else {
          $tmpparms = "\"" . $newparms;
          $newparms = $tmpparms . $DELIMITER . $MGDRSRC . $DELIMITER . $handles . $newparms1;
      }
      $newparms .= "\"";
      ++$count;
   }
} else {
   $newparms .=  $newparms1;

   $newparms = "\"" . $newparms . "\"";
}

$i =  $#$mkrsrcapi_parm;
if ( ($i<0) || (length($$mkrsrcapi_parm[$i]) > $CMD_LIMIT) ) {
    $$mkrsrcapi_parm[$i+1] .= " " . $newparms;
}
else {
    $$mkrsrcapi_parm[$i] .= " " . $newparms;
}
 
return (@$mkrsrcapi_parm);
 
}   # end setup_mkrsrcapi

#--------------------------------------------------------------------#
# make_resources      - Uses the mkrsrc-api interface to define      #
#                       the resources with the specified attributes  #
#                       for the specified class.                     #
#                                                                    #
# Paramaters:                                                        #
#   $passopts           Options to pass to the capi(Trace or Verbose)#
#   $rsrcapi_parms      Attributes and class parameters.             #
#                                                                    #
# Returns:                                                           #
#   $rc              return code                                     #
#                    0  if successful                                #
#                    CHARM_CLI_USER_ERROR if RMC_CLI_USER_ERROR      #
#                                                                    #
# Global Variables:                                                  #
#   $main::Trace     in case trace is on                             #
#   $main::PROGNAME  for trace message                               #
#--------------------------------------------------------------------#
sub make_resources{

my $passopts = shift @_;
my ($rsrcapi_parms) = @_;
my $i = 0;
my $rc =0;
my @good_handles;
my @mkrsrcapi_parms = @$rsrcapi_parms;

for($i=0; $i<=$#mkrsrcapi_parms;$i++){
 
    $Verbose && printIMsg("IMsgCHARMcliDefiningRsrc", $rsrc_class);

    if ($main::Trace) { print STDERR "Calling mkrsrc-api:\n";
         print STDERR "mkrsrc-api parameters:";
         print STDERR "@mkrsrcapi_parms\n";
    }


   ($rc,@good_handles) = mkrsrcapi_resources($passopts,$mkrsrcapi_parms[$i]);
   if ($rc != 0) {
        $badrc = $rc;}            # more important rc
 
   if ($Verbose && $rc == 0) {
       my $rsrc_handle = rsrc_handle_to_string($response->rsrc_hndl);
       printIMsg("IMsgmkrsrcDefinedRsrc", $response->class_name,
           $rsrc_handle);
   }
}
 
$ENV{'CT_CLI_QUOTE_STRING'}  = 1;                 # Enable quotes    
return($rc);
}

#--------------------------------------------------------------------#
# get_mgdrscehandles - Function will parse input format for the mana-#
#                      ged resources and then find its corresponding #
#                      resource handles from its class.              #
#                                                                    #
# Parameters:                                                        #
#   %member_resources input   Managed Resource input format.         #
#                                                                    #
# Return:                                                            #
#   $rc               return code.                                   #
#   $mkrsrcapi_opts   Managed resource handles with DELIMITTERS.     #
#                                                                    #
# Global References:                                                 #
#                                                                    #
#--------------------------------------------------------------------#
sub get_mgdrsrchandles{

my (%member_resources) = @_;
my $lsrsrcapi_opts     = "";
my @act_resources      = ();
my %all_resources      = ();
my @resource_handles   = ();
my $mkrsrcapi_opts     = "";
my $count              = 0;

# Generate operands for lsrsrcinfo command
($lsrsrcinfo_opts,@act_resources) = gen_operands($main::Opt_SelectString,%member_resources);
 
# Get resource handles
%all_resources = get_resourcehandles($main::Opt_SelectString,$lsrsrcinfo_opts);
 
# get all resource handles
@resource_handles = (keys %all_resources);
 
# If resource exists
if ($main::Opt_ResourceExist) {
 
    # Pick only the resource handles that don't already exists as members
    ($rc,$main::Opt_MbrRsrcExists, $main::Opt_MbrRsrcNotExists,@resource_handles) = check_if_handles_exists($main::RsrcHasToExist,$RGrp,%all_resources);
    unless($rc == 0){ 
       return($rc,$mkrsrcapi_opts);
    }
    # unless all nodes are allowed
    unless ($NO_CHECK_REQUIRED) {
         @new_handles = check_if_members_are_allowed($RGrp,\@resource_handles,\@NodeNameList);
    } else { # NO_CHECK_REQ
         # for any resources
         @new_handles = @resource_handles;
    }
   # if at least one resource exits on the allowed nodes
   # prepare to add them to resource group
    if(scalar(@new_handles) > 0){

        foreach $handle (@new_handles){

            unless ($count == 0)
            {
                $MULT_MGDHANDLES  = $TRUE;
                $mkrsrcapi_opts .= $DELIMITER;
            }
            $handle =~ s/"//g;
            $mkrsrcapi_opts .= $handle;
            ++$count;
        }
        
 
    }
} else {
    # If none of the resources exists
    printCEMsg("EMsgCHARMcliNoResourcesExists");
    $rc = CHARM_CLI_NO_RSRC_FOUND;
}
  

return($rc,$mkrsrcapi_opts);
}

#--------------------------------------------------------------------#
# get_sourcehandles - Function will parse input format for the source#
#                     resource and then find its corresponding resou-#
#                     rce handles from its class.                    #
#                                                                    #
# Parameters:                                                        #
#   $source           input   Source input format.                   #
#   $source_string    input   source selection string.               #
#                                                                    #
# Return:                                                            #
#   $rc               return code.                                   #
#   $srchndl          Source resource handle.                        #
#                                                                    #
# Global References:                                                 #
#                                                                    #
#--------------------------------------------------------------------#
sub get_sourcehandles{

my ($source,$source_string) = @_;
my $srchndl             = "";

my ($source_opts,$source_resource) = parse_sourceresources($source,$source_string,$main::Opt_Source_Select);
 
# Convert to hashes
my %source_rsrc = %$source_resource;
 
# Source classes
my @source_class = keys %source_rsrc;
 
# If no source resources specified exit
unless (scalar (@source_class) > 0) {
    printEMsg("EMsgmkrelNoSourceResourcesExist");
    exit(CHARM_CLI_NO_RSRC_FOUND);
}
 
# Get source resource handles
my %act_resources = get_resourcehandles($main::Opt_Source_Select,$source_opts);
 
if ($main::Opt_AllResourcesMissing) {
    $rc = CHARM_CLI_NO_RSRC_FOUND;
}
 
if ($main::Opt_TooManySource) {
    $rc = CHARM_CLI_USER_ERROR;
}

# Source resource handles
my @source_handle = keys %act_resources;
 
 
# Source 
$srchndl = $source_handle[0];

return($rc,$srchndl);
}

#--------------------------------------------------------------------#
# get_sd_element_dtypes - for the specified attribute name return    #
#                         an array of this SDs element's data types  #
#                         in element index order.                    #
#                                                                    #
# Parameters:                                                        #
#   %$rHoSDAttrDefs   input   Reference to a hash of persistent      #
#                             structured data attributes.            #
#                             key  = attribute name                  #
#                             data = array of hashes, each hash      #
#                             represents one of this SDs elements    #
#   $attr_name        input   Attribute name.                        #
#                                                                    #
# Return:                                                            #
#   @sd_element_dtypess       Returns a reference to an array of     #
#                             the SD element data types in element   #
#                             index order for this attribute.        #
#                                                                    #
# Global References:                                                 #
#   None.                                                            #
#--------------------------------------------------------------------#
sub get_sd_element_dtypes {
my ($rHoSDAttrDefs, $attr_name) = @_;
my @sd_element_dtypes;
my %index_to_dtype = ();
my $element;
my $element_cnt = 0;
 
my @elements = keys %{ $rHoSDAttrDefs->{$attr_name} };
foreach $element (@elements) {
    $index = $rHoSDAttrDefs->{$attr_name}{$element}->{sd_index};
    $index_to_dtype{$index} =
        $rHoSDAttrDefs->{$attr_name}{$element}->{sd_dtype};
    $element_cnt++;
}
 
for ($i = 0; $i < $element_cnt; $i++) {
    push @sd_element_dtypes, $index_to_dtype{$i};
}
 
return (@sd_element_dtypes);
}   # end get_sd_element_dtypes

#--------------------------------------------------------------------#
# VerifyPriorityRequest - Will check the validity of the Action      #
#                         request on managed resources or resource   #
#                         group.                                     #
#                                                                    #
# Parameters:                                                        #
#   $priority         input   Raw Priority value.                    #
#                                                                    #
# Return:                                                            #
#   $rc               return code.                                   #
#   $priority         Valid value of priority request.              #
#                                                                    #
# Global References:                                                 #
#   None.                                                            #
#--------------------------------------------------------------------#
sub VerifyPriorityRequest{
    
my $priority = shift @_;
my $rc        = 0;
 
 # Make sure priority is a number (hex, octal or decimal)
if ($priority =~ /^(0x|\d+)\d*/) {
    # Convert  specified in hex or octal to decimal
    $priority = oct $priority if $priority =~ /^0/;
    unless(($priority == $low)||($priority == $high)||($priority == $force)){
       $rc = CHARM_CLI_BAD_OPERAND;
    }
} elsif ($priority =~ /^$LOW$/i) {                   # $A0  $A2
    $priority = $low;
    $main::Opt_LowPriority = $TRUE;        
} elsif ($priority =~ /^$HIGH$/i) {                  # $A0  $A2
    $priority = $high;
    $main::Opt_HighPriority = $TRUE;      
} elsif ($priority =~ /^$FORCE$/i) {                 # $A0  $A2
    $priority = $force;
    $main::Opt_ForcePriority = $TRUE;    
} else {
    $rc = CHARM_CLI_BAD_OPERAND;
}
return($rc,$priority);
}

#--------------------------------------------------------------------#
# VerifyActionRequest- Will check the validity of the Action request #
#                      on managed resources or resource group.       #
#                                                                    #
# Parameters:                                                        #
#   $action           input   Raw Action value.                      #
#                                                                    #
# Return:                                                            #
#   $rc               return code.                                   #
#   $action           Valid value of Action request.                 #
#                                                                    #
# Global References:                                                 #
#   None.                                                            #
#--------------------------------------------------------------------#
sub VerifyActionRequest{
    
my $action = shift @_;

# Make sure priority is a number (hex, octal or decimal)
if ($action =~ /^(0x|\d+)\d*/) {
    # Convert  specified in hex or octal to decimal
    $action = oct $action if $action =~ /^0/;
    unless(($action == $start)||($action == $stop)||($action == $cancel)||($action == $move)||($action == $lock)||($action == $unlock)||($action == $movecancel)){
       $rc = CHARM_CLI_BAD_OPERAND;
    }
} elsif ($action =~ /^$START$/i) {                  # $A0  $A2
    $action = $Start;
    $main::Opt_StartAction = $TRUE;        
} elsif ($action =~ /^$STOP$/i) {                   # $A0  $A2
    $action = $Stop;
    $main::Opt_StopAction = $TRUE;        
} elsif ($action =~ /^$MOVE$/i) {                   # $A0  $A2
    $action = $Move;
    $main::Opt_MoveAction = $TRUE;        
} elsif ($action =~ /^$CANCEL$/i) {                 # $A0  $A2
    $action = $Cancel;
    $main::Opt_CancelAction = $TRUE;        
} elsif ($action =~ /^$LOCK$/i) {                   # $A0  $A2
    $action = $Lock;
    $main::Opt_LockAction = $TRUE;        
} elsif ($action =~ /^$UNLOCK$/i) {                 # $A0  $A2
    $action = $Unlock;
    $main::Opt_UnlockAction = $TRUE;        
} elsif ($action =~ /^$MOVECANCEL$/i) {             # $A0  $A2
    $action = $MoveCancel;
    $main::Opt_MoveCancelAction = $TRUE;        
} elsif ($action =~ /^$STARTOVR$/i) {               # $A0  $A2
    $action = $StartOvr;
    $main::Opt_StartOvrAction = $TRUE;        
} elsif ($action =~ /^$STOPOVR$/i) {                # $A0  $A2
    $action = $StopOvr;
    $main::Opt_StopOvrAction = $TRUE;        
} else {
    $rc = CHARM_CLI_BAD_OPERAND;
}
return($rc,$action);
}

#--------------------------------------------------------------------#
# getNodeIds            - Retreives NodeIds if possible for all the  #
#                         specified nodes.                           #
#                                                                    #
# Parameters:                                                        #
#   @nodes         input   Node names                                #
#                                                                    #
# Return:                                                            #
#   $rc            Output  Return code                               #
#   @node_ids      Output  Valid NodeIds if any.                     #
#   @invalid_nodes Output  Invalid Nodes if any.                     #
#                                                                    #
# Global References:                                                 #
#    CHARM_CLI_BAD_OPERAND                                           #
#    $RSRCNODE                                                       #
#--------------------------------------------------------------------#
sub getNodeIds {

my (@nodes)       = @_;
my $rc            = 0;
my @invalid_nodes = ();
my @handles       = ();
my @attributes    = ();
my $HANDLES       = $FALSE;
my $attr_opts     = " -a NodeIDs"; 

foreach $node (@nodes){
    $attr_opts .= " -o $RSRCNODE" . "::" . $node; 
}
@attributes =  get_resource_attributes($HANDLES, $attr_opts,@handles);
$node_cnt = scalar(@nodes);
for($i =0;$i < $node_cnt; $i++){

    my ($class,$name, $nodeid) = split("::",$attributes[$i]);
    if($nodeid eq ""){
      push @invalid_nodes, $nodes[$i];
      $rc = CHARM_CLI_BAD_OPERAND;
    }else {
      push @node_ids, $nodeid; 
    }
 
}        

return ($rc,\@node_ids, \@invalid_nodes);   
}
#--------------------------------------------------------------------#
# translate_ActionRequest -  This will translate the Action Request  #
#                            value to an English translation.        #
#                                                                    #
# Parameters:                                                        #
#   $action_value     input   Actual Action integer value.          #
#                                                                    #
# Return:                                                            #
#   $action{action_value}         Output English Transalation        #
#   "?"                           Output  Cannot be Transalated      #
#                                                                    #
# Global References:                                                 #
#--------------------------------------------------------------------#
sub translate_ActionRequest{

my $action_value  = shift @_;
my $action_present= $FALSE;                             
my %action        = ();

# actionty translations                     
$action{$Start}   = $START;
$action{$Stop}    = $STOP;
$action{$Move}    = $MOVE;
$action{$Cancel}  = $CANCEL;
$action{$Lock}    = $LOCK;
$action{$Unlock}  = $UNLOCK;
$action{$MoveCancel}  = $MOVECANCEL;
$action{$StartOvr} = $STARTOVR;
$action{$StopOvr} = $STOPOVR;
$action{""}       = $None;

                                                
# see if actionty exists                 
if (defined $action{$action_value}) {             
    $action_present = $TRUE;                             
} 

# return translated action                            
if ($action_present) {                                   
   return $action{$action_value};         
}                                            
else {                                          
   #return "?";                          
   return $None;                          
}                                            
}# End translate_ActionRequest
#--------------------------------------------------------------------#
# translate_PriorityRequest -  This will translate the Priority Requ-#
#                              est value to an English translation.  #
#                                                                    #
# Parameters:                                                        #
#   $priority_value    input   Actual priority integer value.        #
#                                                                    #
# Return:                                                            #
#   $priority{priority_value} Output English Transalation            #
#   "?"                           Output  Cannot be Transalated      #
#                                                                    #
# Global References:                                                 #
#--------------------------------------------------------------------#
sub translate_PriorityRequest{

my $priority_value  = shift @_;
my $priority_present= $FALSE;                             
my %priority        = ();

# Priority translations                     
$priority{$low}     = $LOW;
$priority{$high}    = $HIGH;
$priority{$force}   = $FORCE;
$priority{""}       = $None;

                                                
# see if priority exists                 
if (defined $priority{$priority_value}) {             
   $priority_present = $TRUE;                             
} 

# return translated priority                            
if ($priority_present) {                                   
   return $priority{$priority_value};         
}                                            
else {                                         
   return $None;                          
   #return "?";                          
}                                            
}# End translate_priority
#--------------------------------------------------------------------#
# translate_ActiveReqStatus -This will translate the Active Request  #
#                            flag to an English translation.         #
#                                                                    #
# Parameters:                                                        #
#   $active_value    input   Actual active Integer value             #
#                                                                    #
# Return:                                                            #
#   $active{active_value} Output English Transalation                #
#   $None                 Output  Cannot be Transalated              #
#                                                                    #
# Global References:                                                 #
#--------------------------------------------------------------------#
sub translate_ActiveReqStatus{

my $active_value  = shift @_;
my $active_present= $FALSE;                             
my %active        = ();

#  translations                     
$active{$Current_Active}     = $CURRENT_ACTIVE;
$active{$InActive}           = $INACTIVE;
$active{$Remove_Done}        = $REMOVE_DONE;
                                                

if (($active_value eq "") ||($active_value  eq " ")){
    return $None;
} elsif (($active_value & $Current_Active) == $Current_Active){             
    return $active{$Current_Active};
} elsif (($active_value & $Current_Active) == $InActive) {             
    return $active{$InActive};
} else {
   return "Unknown";                          
}
    
}# End translate_ActiveReqStatus

#--------------------------------------------------------------------#
# hex2chr         - This function will convert hex data from action  #
#                   to its character(ASCII) representation.          #
#                                                                    #
# Parameters:                                                        #
#   $txt         input   Actual data for convertion                  #
#                                                                    #
# Return:                                                            #
#   $data       Output   Converted data                              #
#                                                                    #
# Global References:                                                 #
#--------------------------------------------------------------------#
sub hex2chr {

my $txt        = shift @_;
my $hex        = "";
my $i          = 0;
my $dec        = 0;
my $data       = "";
my $bin_len    = 0;
use bytes;
my $xs;

 # total number of bytes

$bin_len= length($txt);
# retreive two bytes from output
# then convert to its character representation
for ($i=2; $i<$bin_len; $i++){
    $hex = substr($txt,$i,2);

    $dec =  ord $hex;
    # Character representation of numbers
    $xs = chr $dec;
    $data .= $xs;
    ++$i;
 }
 return $data;
} # End of hex2chr

#--------------------------------------------------------------------#
# translate_DesiredState -  This will translate the Desired state for#
#                            TEC.                                    #
#                                                                    #
# Parameters:                                                        #
#   $state_value    input    Actual Desired state value.             #
#                                                                    #
# Return:                                                            #
#   $state{$state_value}     Output English Transalation             #
#   "?"                      Output Cannot be Transalated            #
#                                                                    #
# Global References:                                                 #
#--------------------------------------------------------------------#
sub translate_DesiredState{

my $state_value  = shift @_;
my $state_present= $FALSE;                             
my %state         = ();

# state translations                     
$state{$DS_NULL}          = "Undefined";      # state is currently undefined
$state{$DS_ONLINE}        = "Online";         # resource to be online
$state{$DS_OFFLINE}       = "Offline";        # resource to be offline
$state{$DS_FORCE_OFFLINE} = "Forced Offline"; # resource to be forced offline 

                                                
# see if state exists                 
if (defined $state{$state_value}) {             
    $state_present = $TRUE;                             
} 

# return translated states                            
if ($state_present) {                                   
   return $state{$state_value};         
}                                            
else {                                          
   return "?";                          
}                                            
}# End translate_DesiredState

#--------------------------------------------------------------------#
# translate_CompoundState-  This will translate the Compound state   #
#                            for TEC.                                #
#                                                                    #
# Parameters:                                                        #
#   $state_value    input    Actual Desired state value.             #
#                                                                    #
# Return:                                                            #
#   $state{$state_value}     Output English Transalation             #
#   "?"                      Output Cannot be Transalated            #
#                                                                    #
# Global References:                                                 #
#--------------------------------------------------------------------#
sub translate_CompoundState{

my $state_value  = shift @_;
my $state_present= $FALSE;                             
my %state         = ();

# state translations                     

$state{$CS_NULL}          = "Undefined";      # state is currently undefined
$state{$CS_PROBLEM}       = "Problem";        # problem: 
$state{$CS_DENIED}        = "Denied";         # automation not allowed
$state{$CS_INHIBITED}     = "Inhibitted";     # depend resources disatisfactory
$state{$CS_AWAITING_AUTOMATION}= "Waiting";   # automation in progress
$state{$CS_IN_AUTOMATION} = "Automation";     # automation in progress
$state{$CS_DEGRADED}      = "Degraded";       # problem:
$state{$CS_SATISFACTORY}  = "Satisfactory";   # 

                                                
# see if state exists                 
if (defined $state{$state_value}) {             
    $state_present = $TRUE;                             
} 

# return translated states                            
if ($state_present) {                                   
   return $state{$state_value};         
}                                            
else {                                          
   return "?";                          
}                                            
}# End translate_CompoundState

#--------------------------------------------------------------------#
# translate_ObservedState -  This will translate the Desired state for#
#                            TEC.                                    #
#                                                                    #
# Parameters:                                                        #
#   $state_value    input    Actual Desired state value.             #
#                                                                    #
# Return:                                                            #
#   $state{$state_value}     Output English Transalation             #
#   "?"                      Output Cannot be Transalated            #
#                                                                    #
# Global References:                                                 #
#--------------------------------------------------------------------#
sub translate_ObservedState{

my $state_value  = shift @_;
my $state_present= $FALSE;                             
my %state         = ();

# state translations                     
$state{$OS_NULL}            = "Undefined";  # state is currently undefined
$state{$OS_UNKNOWN}         = "Unknown";    # state not yet detected
$state{$OS_SYSTEM_GONE}     = "System Unavailable";  # connection to system lost
$state{$OS_OFFLINE}         = "Offline";    # resource is currently offline
$state{$OS_FAILED}          = "Failed Offline";     # resource cant be started
$state{$OS_PENDING_ONLINE}  = "Pending Online";  # resource is starting
$state{$OS_ONLINE}          = "Online";     # resource is currently online
$state{$OS_DEGRADED}        = "Degraded";   # problem: 
$state{$OS_STUCK_ONLINE}    = "Stuck Online";  # resource can?t be stopped
$state{$OS_PENDING_OFFLINE} = "Pending Offline"; # resource is stopping
$state{$OS_WAS_ONLINE}      = "Was Online"; # connection to resource lost
$state{$OS_INELIGIBLE}      = "Ineligible"; # problem: SA_STANDBY

                                                
# see if state exists                 
if (defined $state{$state_value}) {             
    $state_present = $TRUE;                             
} 

# return translated states                            
if ($state_present) {                                   
   return $state{$state_value};         
}                                            
else {                                          
   return "?";                          
}                                            
}# End translate_ObservedState

#--------------------------------------------------------------------#
# translate_BindingState -  This will translate the Binding state for#
#                            TEC.                                    #
#                                                                    #
# Parameters:                                                        #
#   $state_value    input    Actual Desired state value.             #
#                                                                    #
# Return:                                                            #
#   $state{$state_value}     Output English Transalation             #
#   "?"                      Output Cannot be Transalated            #
#                                                                    #
# Global References:                                                 #
#--------------------------------------------------------------------#
sub translate_BindingState{

my $state_value  = shift @_;
my $state_present= $FALSE;                             
my %state         = ();

# state translations                     
$state{$BS_NULL}           = "Undefined";  # state is currently undefined
$state{$BS_UNBOUND}        = "Unbound";    # not dedicated to a system
$state{$BS_BOUND}          = "Bound";      # dedicated to a system
$state{$BS_UNWANTED}       = "Unwanted";   # resource is not in use
$state{$BS_UNBINDABLE}     = "UnBindable"; # configuration is incorrect
$state{$BS_SACRIFICED}     = "Sacrificed"; # does not comply with configuration
$state{$BS_SACRIFICIAL}    = "Sacrificial"; #does not comply with configuration
$state{$BS_WAITING}        = "Waiting";    # automation in progress

                                                
# see if state exists                 
if (defined $state{$state_value}) {             
    $state_present = $TRUE;                             
} 

# return translated states                            
if ($state_present) {                                   
   return $state{$state_value};         
}                                            
else {                                          
   return "?";                          
}                                            
}# End translate_BindingState

#--------------------------------------------------------------------#
# translate_AutomationState-This will translate the Automation State #
#                            for TEC.                                #
#                                                                    #
# Parameters:                                                        #
#   $state_value    input    Actual Desired state value.             #
#                                                                    #
# Return:                                                            #
#   $state{$state_value}     Output English Transalation             #
#   "?"                      Output Cannot be Transalated            #
#                                                                    #
# Global References:                                                 #
#--------------------------------------------------------------------#
sub translate_AutomationState{

my $state_value  = shift @_;
my $state_present= $FALSE;                             
my %state         = ();

# state translations                     
$state{$AS_NULL}          = "Undefined";  # state is currently undefined
$state{$AS_UNKNOWN}       = "Unknown";    # state not yet detected
$state{$AS_SYSTEM_GONE}   = "System Unavailable";  # system is not available
$state{$AS_IDLE}          = "Idle";       # no automation in progress
$state{$AS_ORDERED}       = "Ordered";    # automation in progress
$state{$AS_BUSY}          = "Busy";       # automation in progress
$state{$AS_DENIED}        = "Denied";     # problem: automation is not allowed
$state{$AS_PROBLEM}       = "Problem";    # problem: automation has a problem
$state{$AS_INTERNAL}      = "Internal";   # automation in progress
                                                
# see if state exists                 
if (defined $state{$state_value}) {             
    $state_present = $TRUE;                             
} 

# return translated states                            
if ($state_present) {                                   
   return $state{$state_value};         
}                                            
else {                                          
   return "?";                          
}                                            
}# End translate_AutomationState

#--------------------------------------------------------------------#
# translate_StartableState -This will translate the Startable state  #
#                            for TEC.                                #
#                                                                    #
# Parameters:                                                        #
#   $state_value    input    Actual Startable state value.           #
#                                                                    #
# Return:                                                            #
#   $state{$state_value}     Output English Transalation             #
#   "?"                      Output Cannot be Transalated            #
#                                                                    #
# Global References:                                                 #
#--------------------------------------------------------------------#
sub translate_StartableState{

my $state_value  = shift @_;
my $state_present= $FALSE;                             
my %state         = ();

# state translations                     
$state{$SS_NULL}             = "Undefined";                      # the resource is  undefined
$state{$SS_STARTABLE}        = "Startable";                      # the resource is startable
$state{$SS_NOT_STARTABLE}    = "NotStartable";                   # the resource is not startable
$state{$SS_START_INHIBITED}  = "StartInhibited";                 # start dependency is not satisfactory 
$state{$SS_DENIED}           = "Denied";                         # automation is not allowed
$state{$SS_STOP_INHIBITED}   = "StopInhibited";                  # stop dependency is not satisfactory 
$state{$SS_NOT_CONTROLLABLE} = "NotControllable";                # resource is not controllable
$state{$SS_NODE_EXCLUDED}    = "NodeExcluded";                   # node is excluded
$state{$SS_NODE_EX_NOT_CONT} = "NodeExcludedAndNotControllable"; # node is excluded and resource not controllable
$state{$SS_REF_BROKEN}       = "BrokenReference";                # resource reference broken (reserved for e2e)
$state{$SS_REF_ERROR}        = "ReferenceInError";               # resource reference error  (reserved for e2e)
$state{$SS_NRE}              = "NonRecoverableError";            # non recoverable error, manual reset required

                                                
# see if state exists                 
if (defined $state{$state_value}) {             
    $state_present = $TRUE;                             
} 

# return translated states                            
if ($state_present) {                                   
   return $state{$state_value};         
}                                            
else {                                          
   return "?";                          
}                                            
}# End translate_StartableState

#--------------------------------------------------------------------#
# translate_HealthState   - This will translate the Health state     #
#                            for TEC.                                #
#                                                                    #
# Parameters:                                                        #
#   $state_value    input    Actual Health state value.              #
#                                                                    #
# Return:                                                            #
#   $state{$state_value}     Output English Transalation             #
#   "?"                      Output Cannot be Transalated            #
#                                                                    #
# Global References:                                                 #
#--------------------------------------------------------------------#
sub translate_HealthState{

my $state_value  = shift @_;
my $state_present= $FALSE;                             
my %state         = ();

# state translations                     
$state{$HS_NULL}           = "Undefined";     # Status Health is not defined 
$state{$HS_SYSTEM_GONE}    = "System Unavailable"; # the system is currently ported
$state{$HS_Unknown}        = "Unknown";       # did not report a health status
$state{$HS_NotApplicable}  = "Not Applicable"; # Status Health is not supported
$state{$HS_Normal}         = "Normal";        # The resource does perform well
$state{$HS_Warning}        = "Warning";       # has a small performance problem
$state{$HS_Minor}          = "Minor";         # has a minor performance problem
$state{$HS_Critical}       = "Critical";      # critical performance problem
$state{$HS_Fatal}          = "Fatal";         # the resource does not perform

                                                
# see if state exists                 
if (defined $state{$state_value}) {             
    $state_present = $TRUE;                             
} 

# return translated states                            
if ($state_present) {                                   
   return $state{$state_value};         
}                                            
else {                                          
   return "?";                          
}                                            
}# End translate_HealthState

#--------------------------------------------------------------------#
# translate_movestatus    - This will translate the Move Status value#
#                            for SAMREQ.                             #
#                                                                    #
# Parameters:                                                        #
#   $status_value    input  Actual Move status value.                #
#                                                                    #
# Return:                                                            #
#   $status{$status_value}   Output English Transalation             #
#   "?"                      Output Cannot be Transalated            #
#                                                                    #
# Global References:                                                 #
#--------------------------------------------------------------------#
sub translate_movestatus{


my $status_value  = shift @_;
my $status_present= $FALSE;                             
my %status         = ();

# state translations                     
$status{$MV_NULL}              = "Undefined";
$status{$MV_NOT_SUPPORTED}     = "Not Supported";  
$status{$MV_NONE}              = "None"; 
$status{$MV_PREPARING}         = "Preparing";
$status{$MV_EXECUTING_STOP}    = "Stopping";
$status{$MV_CANCELING}         = "Canceling";
$status{$MV_EXECUTING_START}   = "Starting";
$status{$MV_EXECUTING_BKOUT}   = "Backing Out "; 
$status{$MV_COMPLETING}        = "Completing";

                                                
# see if state exists                 
if (defined $status{$status_value}) {             
    $status_present = $TRUE;                             
} 

# return translated states                            
if ($status_present) {                                   
   return $status{$status_value};         
}                                            
else {                                          
   return "?";                          
}                                            
}# End translate_movestatus

# Start of block $A1
#--------------------------------------------------------------------#
# translate_EventFilter    - This will translate the Event Filter    #
#                            value for Subscription                  #
#                                                                    #
# Parameters:                                                        #
#   $status_value    input  Actual Event Filter value.               #
#                                                                    #
# Return:                                                            #
#   $status{$status_value}   Output English Transalation             #
#   "?"                      Output Cannot be Transalated            #
#                                                                    #
# Global References:                                                 #
#--------------------------------------------------------------------#
sub translate_EventFilter{

my $status_value  = shift @_;
my $status_present= $FALSE;                             
my %status         = ();

# state translations                     
$status{$ES_FI_NONE}           = "None";
$status{$ES_FI_INITIAL}        = "InitEvent";  

                                                
# see if state exists                 
if (defined $status{$status_value}) {             
    $status_present = $TRUE;                             
} 

# return translated states                            
if ($status_present) {                                   
   return $status{$status_value};         
}                                            
else {                                          
   return "?";                          
}                                            
}# End translate_EventFilter

#--------------------------------------------------------------------#
# translate_EventFamily    - This will translate the Event Family    #
#                            value for Subscription                  #
#                                                                    #
# Parameters:                                                        #
#   $status_value    input  Actual Event Family value.               #
#                                                                    #
# Return:                                                            #
#   $status{$status_value}   Output English Transalation             #
#   "?"                      Output Cannot be Transalated            #
#                                                                    #
# Global References:                                                 #
#--------------------------------------------------------------------#
sub translate_EventFamily{

my $status_value  = shift @_;
my $status_present= $FALSE;                             
my %status         = ();

# state translations                     
$status{$ES_FA_CONFIG}        = "Config";
$status{$ES_FA_STATUS}        = "Status";  
$status{$ES_FA_ALL}           = "All";  

                                                
# see if state exists                 
if (defined $status{$status_value}) {             
    $status_present = $TRUE;                             
} 

# return translated states                            
if ($status_present) {                                   
   return $status{$status_value};         
}                                            
else {                                          
   return "?";                          
}                                            
}# End translate_EventFamily

# End of block $A1

#--------------------------------------------------------------------#
# VerifyExcludedlist  - Will check the validity of the Excludedlist  #
#                       attribute value for ResourceGroup.           #
#                                                                    #
# Parameters:                                                        #
#   $excludedlist   input  Raw Excludedlist  attribute value.        #
#                                                                    #
# Return:                                                            #
#   $rc               return code.                                   #
#   $members          Valid member resource handle list.             #
#                                                                    #
# Global References:                                                 #
#   None.                                                            #
#--------------------------------------------------------------------#
sub VerifyExcludedlist {
 
my ($excludedlist)  = @_;
my $rc        = 0;
my $member_string = "";
my $members      = "";
my $node_name    = "";
my %excluded_nodes = ();

$excludedlist =~ s/"//g;
$excludedlist =~ s/\{//g;
$excludedlist =~ s/\}//g;
unless($excludedlist =~ /^(0x|\d+)\d*/) {
    if(!defined $excludedlist){
      printCEMsg("EMsgCHARMcliMissingResources",$MCLASS);
      $rc = CHARM_CLI_BAD_OPERAND;
      return($rc,$members);
    }
    my @resources = split(/,/,$excludedlist);
    if (scalar @resources > 0) {
       # if node name is specified
       foreach $resource (@resources) {
           $node_name = $resource;
           $node_name .= ":" . $resource;
           push (@{$excluded_nodes{$RSRCNODE}},$node_name);
       }

       # Generate node operands for lsrsrcinfo command
       my ($lsrsrcinfo_opts,@act_nodes) = gen_operands($OptSelectString,%excluded_nodes);

       # Get excluded node resource handles
       my %act_excluded_nodes = get_resourcehandles($OptSelectString,$lsrsrcinfo_opts);

       my @act_nodehandles = keys %act_excluded_nodes;
       my $count =0;
       foreach $resource (@act_nodehandles)
       {
           unless($count == 0){
              $members .= "," . $resource;
              ++$count;
              next;
           }
           $members =  "{" . $resource;
           ++$count;

        }
        if( $count > 0){
           $members .=  "}";
           ($rc, $members) = convert_input_value_api($DTYPE, $members);
        } else {
           printCEMsg("EMsgCHARMcliNoResourcesExists");
           $rc = CHARM_CLI_BAD_OPERAND;
        }
     } else {
           $members = "{}";
     }
}

return ($rc,$members);
}

#--------------------------------------------------------------------#
# update_subscription_lists   -  This function will update the subsc-#
#                         ription list. It will report the existance #
#                         of duplicate subscriptions when adding or  #
#                         the non-existance of subscriptions when    #
#                         Removing.                                  #
#                                                                    #
# Parameters:                                                        # 
#   $subscript_list   input    desired list of subscriptions         #  
#   $Opt_Add          input    Add operation.                        #
#   @curr_subscripts  input    Current subscriptions.                #
#                                                                    #
# Return:                                                            #
#   @new_subscritions Output   new value of subscriptions.           #
#                                                                    #
# Global References:                                                 #
#   Trace             input  Trace call & return of extension.       #
#                                                                    # 
#--------------------------------------------------------------------#  
sub update_subscription_lists {                                                       

my $subscript_list   = shift @_;           # desired subscriptionsnodes
my $Opt_Add          = shift @_;           # Adding a subscription
my (@curr_subscripts)= @_;                 # Current subscriptions
my $new_subscripts   = "";           
my @new_subscripts   = ();                 # list of new subscriptions
my @old_subscripts   = ();                 # list of old subscriptions
my $count            =  0;                 # counter
my $curr_sub         = "";                 # each old node 
my $new_sub          = "";                 # each old node 
my $subscription     = "";                 # each handle  
my $junk             = "";                 # 
my $Found            = $FALSE;             # Node not found    
my $AtLeastOneFound  = $FALSE;             # Not even one node found/matched
my $NoneFound        = $FALSE;             # No Nodes matched  
my %seen;                                
my @new_subscriptions   = ();              # list of new node handles  
my @matching_subscripts = ();              # list of all matching node handles

chomp($subscript_list);                            
my ($junk,$new_subscripts) = split (/[{}]/,$subscript_list);
$new_subscripts =~ s/{//g; 
$new_subscripts =~ s/}//g; 
$new_subscripts =~ s/],/]$Key/g; 
@new_subscripts = split(/$Key/,$new_subscripts);
                                       
# find matching subscripton if any
foreach $new_sub (@new_subscripts) {                                            

   foreach $curr_sub (@curr_subscripts) {                                        
      if ($curr_sub eq $new_sub) {                                            
          $AtLeastOneFound = $TRUE;                                      
          $Found = $TRUE; 
          if ($Opt_Add) {                                               
              printCEMsg("EMsgCHARMcliSubscriptDoesExist",$new_sub);     
          } else {  
              push @matching_subscripts, $new_sub;
          }   
          last;
      }
      $Found = $FALSE;
   }                
   if (!$Found) {
       $NoneFound = $TRUE;
       if ($Opt_Add) { 
            push @new_subscriptions, "\"$new_sub\"";
       } else  { 
            printCEMsg("EMsgCHARMcliSubscriptDoesNotExist",$new_sub);
       }
   }
   ++$count;
}   
                 
# Reset Found 
$Found = $FALSE;
                    
if (!$Opt_Add) {                                                        
   unless ($AtLeastOneFound){            
       printCEMsg("EMsgCHARMcliNoSubscriptsExists");
       exit(CHARM_CLI_NO_RSRC_FOUND); 
   } 
                              
   # Building lookup table       
   @seen{@matching_subscripts} = (); 
   foreach $curr_sub (@curr_subscripts) {                                        
       push(@new_subscriptions, "\"$curr_sub\"") unless exists $seen{$curr_sub};
   }   
} else {
   unless ($NoneFound){                                         
       printCEMsg("EMsgCHARMcliAllSubscriptsExists");                          
       exit(CHARM_CLI_RSRC_EXISTS);
   }
   foreach $curr_sub (@curr_subscripts) {                                        
       push(@new_subscriptions, "\"$curr_sub\"");
   }   
}                                  
return @new_subscriptions;               
} # end update_subscriptions_lists        
#--------------------------------------------------------------------#
# End Exported Subroutines (with @EXPORT_OK, -> on demand).          #
#--------------------------------------------------------------------#
#--------------------------------------------------------------------#
# End File.                                                          #
#--------------------------------------------------------------------#
